// Creator: Andrew Mascolo
 #include <Wire.h>
#include <OnewireKeypad.h>

char KEYS[] = {
  '1', '2', '3', 'A',
  '4', '5', '6', 'B',
  '7', '8', '9', 'C',
  '*', '0', '#', 'D'
};
int Aval;
float Volt;
OnewireKeypad <Print, 12 > KP(Serial, KEYS, 4, 4, A7, 4700, 1000);

void setup () {
  Serial.begin(115200);

  KP.SetHoldTime(500);
  
  // This method is set in the constructor with a default value of 5.0
  // You only need to include this if your Arduino is not supplying 5v to
  // the keypad. ie. ~4.7v or even with 3.3v Arduino boards too.
  
  KP.SetKeypadVoltage(4.76);
  
  KP.ShowRange();
}

void loop() {
  char Key;
  byte KState = KP.Key_State();

  if (KState == PRESSED) {
    if ( Key = KP.Getkey() ) {
      Serial << "Pressed: " << Key << "\n";
      Serial.println(Key, DEC);
    }
  } else if (KState == HELD) {
    Serial << "Key:" << KP.Getkey() << " being held\n";
    Key=KP.Getkey();
    Aval=analogRead(7);
    Volt=Aval*5;
    Volt=Volt/1024;
    Serial.println(Aval);
  }
}

