
/* Test program 1 - LCD test
 requires lcd1602 I2C or LCD2004 I2C, uses SDA/SCL A4/A5

 Run this program with the Serial port monitor so that you can see what happens....

 This is for the v3 hardware 
 DO not run this on the older v2 hardware.
*/

#include <Arduino.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>    // needed for LCD1602-I2C

// change LINE 13 to match your LCDTYPE, example is for LCD1602

// define LCD supported types
#define LCD1602  1        // support for two different LCD types 16 character by 2 line
#define LCD2004  2        // or 20 character by 4 line 
#define MYLCDTYPE  LCD1602  // set for the 16x2 display, if using 20x4 then change
int cntr;

// LiquidCrystal_I2C lcd(0x27, 16, 2); // if using LCD2004 then comment this line out and uncomment next one below
// LiquidCrystal_I2C lcd(0x27, 20, 4);    // if using LCD1602 then comment this line out and uncomment previuos one above
 LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  

void setup() {
  Serial.begin(115200);    // initialise serial port

  Serial.println("Test Program 1: LCDXXXX+I2C");
  // initialise the lcd display
//  lcd.init();
  lcd.begin(16,2); // 16 characters across - 2 lines
  lcd.backlight();
  lcd.print("Dew Control");
  lcd.setCursor( 0, 1 );              // col, row
  lcd.print("Test");
  lcd.setCursor( 0, 2 );              // col, row
  lcd.print("Test");
  delay(2000);
  Serial.println("If the LCD appears on - you should see some light - then adjust the backlight setting");
  Serial.println("which is a small potentiometer on the I2C board that you turn with a little screwdriver");
  Serial.println();
  Serial.println("If there is no light at all, check all your connections to the LCD, VCC, GND, SDA=A4, SCL=A5");
  cntr=0;
}

// --------------------------------------------------------
void loop() {
  lcd.clear();
  lcd.setCursor( 0, 0 );
  lcd.print("Dew Control");
  lcd.setCursor( 0, 1 );              // col, row
  lcd.print(cntr);
  cntr=cntr+1;
  if (cntr >9) cntr=0;
  delay(2000);
}

