//**************************************************************************************
//PC Communications Variables
uint8_t slength[] {1,0,0,10,0,0,1,0,0,9,0,1,2,1,1,0,0,8,   //63-80
                   0,10,10,2,0,1,9,0,0,1,0,0,0,0,0,0,0,0,   //81-98
                   0,0,1,0,0,1,0,0,0,0,1,0,0,0,0,18,18,1,0,0,1,0,0,1  //99-122
                };
byte receivedChars[20];                                   //Received bytes buffer
byte numChars;
boolean firstChar=true;
boolean newData = false;
uint32_t TimeOut=0;

void setup() {
    Serial.begin(115200);
    Serial.println("<Arduino is ready>");
}

void loop() {
    recvWithCounter();
    if(newData)
      showNewData();
    if(TimeOut !=0 and TimeOut < millis())
      {
            firstChar=true;
            newData = false;
            TimeOut=0;
      }
      
}

void recvWithCounter() {
    static boolean recvInProgress = false;
    static byte ndx = 0;
    byte rc;
 //recvInProgress is false until after receive first byte. First byte determines the number of characters to follow
 // if (Serial.available() > 0) {
    while (Serial.available() > 0 && newData == false) {
        rc = Serial.read();
        if(firstChar)
         {
          if(rc > 62 && rc < 123)
          {
//            Serial.println(rc,HEX);
            numChars=slength[rc-63];                 //Get number of charcters to read
//            Serial.println(numChars);
            recvInProgress = true;
            firstChar=false;
            ndx=0;
            TimeOut=millis()+3;
          }
          else
          {
            numChars=0;
            recvInProgress = false;
            firstChar=true;
            ndx = 0;
            newData = false;
            TimeOut=0;
          }
         }
          if (recvInProgress == true && numChars > 0) {
              if (ndx < numChars) {
                  receivedChars[ndx] = rc;
//                  Serial.println(rc,HEX);
                  ndx++;
//                    Serial.print("ndx-");
//                    Serial.println(ndx);
                  if (ndx == numChars) {
                    recvInProgress = false;
                    firstChar=true;
                    ndx = 0;
                    newData = true;
                    TimeOut=0;
                 }
              }
              else
              {
                  recvInProgress = false;
                  ndx = 0;
                  firstChar=true;
                  newData = false;
                  TimeOut=0;
              }
          }
      }
}

void showNewData() {
  char Chrdat;
    if (newData == true) {
        Serial.print("This just in ... ");
        for( int cnt=0; cnt < numChars; cnt++){
          Chrdat=receivedChars[cnt];
        Serial.print(Chrdat);
        }
        Serial.println();
      firstChar=true;
      newData = false;
      TimeOut=0;
    }
}
