#include <Wire.h>
#include <math.h>

struct config_t
{
  int Zfield;                 // If the first character is 99 that says the data has been written previously and is valid
  // If the first character is an "F" then the data location has been written, but is not valid
  unsigned int eeAccess;        // Number of times the data has been accessed
  boolean RAEQN;                  //Normal Direction of RA in EQN moves drive CounterClockwise
  boolean DECEQN;           //Normal Direction of DEC UP button moves Positive North when scope is on the East Side of mount
  long itemEnable;              // enabled flags for each menu item.

  //**************************************************************************************
  // Locaton variables
  int LatDeg;                      //Latitude Degrees
  int LatMin;                      //Latitude Minutes
  int LatSec;                      //Latitude Seconds
  int LatDir;                      //Latitude Direction 0=Norh 1=South
  int LongDeg;                      //Longitude Degrees
  int LongMin;                      //Longitude Minutes
  int LongSec;                      //Longitude Seconds
  int LongDir;                      //Longitude Direction 0=East 1=West

} Configs;

byte buttons;

void addToInt(int*);

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  Configs.LatDeg=5;
  Serial.print("Num before call =");
  Serial.println(Configs.LatDeg);
  addToInt(&Configs.LatDeg);
  Serial.print("Num after call =");
  Serial.println(Configs.LatDeg);
 
 }

void loop() {
  // put your main code here, to run repeatedly:
  

}

void SetMenu(byte num1,int valmax, int* valA, int* valMin, int* valSec, int* valDir)
{
  byte LFLt[13]
  if(num1==2)
    LFLt={-10,0,0,1,0,0,1,0,0,1,0,-10,0};
  if(num1==3)
    LFLt={-11,0,0,0,1,0,0,1,0,0,1,0,-11};

  prevButton=buttons;
  Serial.println(buttons);
  
  switch(buttons){
  case 1:
  // Save and return
  inMenu=0;
  printStatus();

  case 2:
         LineFlag=LineFlag+1;
         LineFlag=LineFlag+LFLt[LineFlag];
         lcd.setCursor(LineFlag,1);
  break;
  
  case 4:
    switch(LineFlag){
      case 1:
       valA=valA-10;
        if(valA<0)
          valA=valA+valmax;
      break;
      case 2:
        valA=valA-1;
        if(valA<0)
          valA=valA+valmax;
      break;
      case 4:
        valMin=valMin-10;
        if(valMin<0)
          valMin=valMin+60;
      break;
      case 5:
        valMin=valMin-1;
        if(valMin<0)
          valMin=valMin+60;
      break;
      case 7:
        valSec=valSec-10;
        if(valSec<0)
          valSec=valSec+60;
      break;
      case 8:
        valSec=valSec-1;
        if(valSec<0)
          valSec=valSec+60;
      break;
      case 10:
        if(valDir == 1)
          valDir=0;
        else
          valDir=1;
      break;
    }
  break;
  
  case 8:
    switch(LineFlag){
      case 1:
        valA=valA+10;
        if(valA>=valmax)
          valA=valA-valmax;
      break;
      case 2:
        valA=valA+1;
        if(valA>=valmax)
          valA=valA-valmax;
      break;
      case 4:
        valMin=valMin+10;
        if(valMin>=60)
          valMin=valMin-60;
      break;
      case 5:
        valMin=valMin+1;
        if(valMin>=60)
          valMin=valMin-60;
      break;
      case 7:
        valSec=valSec+10;
        if(valSec>=60)
          valSec=valSec-60;
      break;
      case 8:
        valSec=valSec+1;
        if(valSec>=60)
          valSec=valSec-60;
      break;
      
      case 10:
        if(valDir == 1)
          valDir=0;
        else
          valDir=1;
      break;
    }
  break;
  
  case 16:
         LineFlag=LineFlag-1;
         LineFlag=LineFlag-LFLt[LineFlag];
         lcd.setCursor(LineFlag,1);
  break;
  
  }
  LatPrint();
}

